package hiloscontando;
public class Main {
    public static void main(String[] args) {
        System.out.println("Startando hilos");
        for (int i=0; i<5; i++) { 
            // Creamos 5 hilos, los 
            // inicializamos p/intervalos 0/9, 10/19, ..., 90/99 
            Thread t = new Thread(new MasUnHilo(i*10, (i+1)*10,i+1)); 
            t.start(); // start invoca a run de CountThreadTest 
        }   // for
        System.out.println("Todos los hilos trabajando");
    }
}

class MasUnHilo extends Thread{ 
    int from;   // Limite inferior del conteo.
    int to;     // Limite superior.
    int hilo;
    public MasUnHilo(int from, int to, int hilo){ // Constructor 
        this.from   = from;
        this.to     = to;
        this.hilo   = hilo;
    }
    public void run(){ 
        try{
            for (int i=from; i<to; i++){ 
                System.out.println("Hilo # "+ hilo+ " - " + i);
                sleep(1000);
            }
        }catch(InterruptedException interr){
            System.out.println("Siesta interrumpida ...");
        }
    }
}
