package prodconsgui;
import java.util.LinkedList;
class Monitor{ 
    private LinkedList <Numero> stock;
    private Numero numerin;
    private boolean vacio    = true; // Almacen vaco
    private boolean repleto  = false; // Almacen muy lleno
    public Monitor(){
        stock = new LinkedList();
    }
 
    public synchronized Numero consumir(Interfaz inter,int cons){
        try{
            while(vacio){ // esperando para consumir 
                inter.mostrarCont("Cons "+ cons+ " => wait(Nada en stock...)\n");
                wait() ;
            }
            // a consumir se ha dicho
            numerin = new Numero();
            if (stock.contains(numerin))
                stock.remove(numerin);
            else{
                inter.mostrarCont("Cons "+ cons+ " => wait(falta "+numerin+")\n");
                wait();
            }
            if(stock.size() == 0)   // Fu el ultimo, ya no quedan
                vacio = true;       // mas objetos Numero
            repleto = false;        // acabamos de consumir
            inter.mostrarCont("Cons "+cons+" =>notifyAll()\n");
            notifyAll() ;
        }catch(InterruptedException exc){;}
        return numerin; // consumimos
    } 

    public synchronized Numero producir(Interfaz inter,int prod){
        try{
            while(repleto){ // Sin lugar para almacenar esta nueva produccin.
                inter.mostrarCont("Prod "+ prod+ " => wait(Stock repleto)\n");
                     wait();
            }
            numerin = new Numero();
            stock.add(numerin);
            if(stock.size()>100)
                repleto = true;
            vacio = false;
            inter.mostrarCont("Prod "+prod+" =>notifyAll()\n");
            notifyAll();
        }catch(InterruptedException exc){;}
        return numerin;
    }

    public synchronized boolean HayStock(){return stock.size() > 0;}
    public int cuantoStock(){
        int cuantos = stock.size();
        return cuantos;
    }
    
}
