package prodconsgui;
class Productor extends Thread{
    private int prod;
    private Interfaz inter;
    private Monitor monitor; 
    public Productor(Interfaz interfaz){	
	this.inter = interfaz;
        this.monitor = interfaz.monitor;
        prod = interfaz.contProd;
    }

    public void run(){
        Numero numerin;
        try{
            while(!inter.finalizar){
                if(!inter.detProd){  //  productores no detenidos
                    numerin = monitor.producir(inter,prod);
                    inter.mostrarDemo("Productor "+ prod+ " -> "
                        + numerin+"\n");
                }
                // Vamos despacio, producir lleva tiempo...
                sleep( (int) (Math.random() * 2000 ) );
            }   //  while
        }catch( InterruptedException e ){
            inter.mostrarCont("InterruptedException en run de Productor");
        }
    }   //  run
}   //  class productor