package prodconsgui;
class Consumidor extends Thread{
    private int cons;
    private Interfaz interfaz;
    private Monitor monitor; 
    public Consumidor(Interfaz interfaz){	
	this.interfaz = interfaz;
        this.monitor = interfaz.monitor;
        cons = interfaz.contCons;
    }

    public void run(){
        Numero numerin;
        try{ //Da una chance al hilo productor
            while(!interfaz.finalizar){
                if(!interfaz.detCons){  //  Consumidores no detenidos
                    numerin = monitor.consumir(interfaz, cons);
                    interfaz.mostrarDemo("Consumidor "+ cons+ " -> "
                        + numerin+"\n");
                }
                sleep( (int) (Math.random() * 10000 ));
            }  // while
        } catch(InterruptedException  e ){;}
    }  // run
} // class consumidor
